﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace NotovyEditor
{
    public partial class Form1 : Form
    {
        // třída spravující soubor s notami (načítání, vykreslování)
        Notes notes;
        
        public Form1()
        {
            InitializeComponent();

            notes = new Notes();
            hScrollBar.Maximum = notes.Count;
        }

        // překreslení not
        private void OwnDraw()
        {
            notes.Draw(hScrollBar.Value, Graphics.FromImage(pictureBox.Image), pictureBox.ClientRectangle);

            pictureBox.CreateGraphics().DrawImage(pictureBox.Image, new Point(0, 0));
        }

        /// <summary>
        /// Při spuštění je třeba vytvořit Image v pictureBoxu, na který se bude kreslit
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Form1_Load(object sender, EventArgs e)
        {
            pictureBox.Image = new Bitmap(Screen.PrimaryScreen.WorkingArea.Width, pictureBox.Height, System.Drawing.Imaging.PixelFormat.Format64bppArgb);
            Graphics.FromImage(pictureBox.Image).Clear(Color.White);
        }

        // při scrollování překreslíme
        private void hScrollBar_Scroll(object sender, ScrollEventArgs e)
        {
            OwnDraw();
        }

        private void načístToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                notes.LoadFromFile(openFileDialog1.FileName);
                OwnDraw();
                hScrollBar.Maximum = notes.Count;
            }
        }
    }
}