﻿using System;
using System.Collections.Generic;
using System.Text;

namespace NotovyEditor
{
    public enum NoteType {
        C, Cis, D, Dis, E, F, Fis, G, Gis, A, Ais, H, c, cis, d, dis, e, f, fis, g, gis, a, ais, h, Pause, Invalid
    }

    public enum NoteGroup { BeginGroup, EndGroup, InGroup, Nothing }
    public enum NoteLength { nl4, nl3, nl2, nl1_5, nl1, nl0_5 }

    class Note
    {
        public static NoteType GetNoteType(string note)
        {
            switch (note)
            {
                case null:
                case "":
                    return NoteType.Pause;
                case "C":
                    return NoteType.C;
                case "Cis":
                    return NoteType.Cis;
                case "D":
                    return NoteType.D;
                case "Dis":
                    return NoteType.Dis;
                case "E":
                    return NoteType.E;
                case "F":
                    return NoteType.F;
                case "Fis":
                    return NoteType.Fis;
                case "G":
                    return NoteType.G;
                case "Gis":
                    return NoteType.Gis;
                case "A":
                    return NoteType.A;
                case "Ais":
                    return NoteType.Ais;
                case "H":
                    return NoteType.H;
                case "c":
                    return NoteType.c;
                case "cis":
                    return NoteType.cis;
                case "d":
                    return NoteType.d;
                case "dis":
                    return NoteType.dis;
                case "e":
                    return NoteType.e;
                case "f":
                    return NoteType.f;
                case "fis":
                    return NoteType.fis;
                case "g":
                    return NoteType.g;
                case "gis":
                    return NoteType.gis;
                case "a":
                    return NoteType.a;
                case "ais":
                    return NoteType.ais;
                case "h":
                    return NoteType.h;
            }
            return NoteType.Invalid;
        }


        public static List<Note> CreateNote(int length, NoteType notetype, int takt, ref int left)
        {
            List<Note> list = new List<Note>(); 
            
            int tmp = 0;

            if (length > left)
            {
                tmp = length - left;
                length = left;
            }

            bool first = true;
            Note last = null;
            bool process = true;

            while (process)
            {
                while (length > 40) { last = new Note(NoteLength.nl4, notetype, (first ? NoteGroup.BeginGroup : NoteGroup.InGroup)); first = false;  list.Add(last); length -= 40; }
                while (length > 30) { last = new Note(NoteLength.nl3, notetype, (first ? NoteGroup.BeginGroup : NoteGroup.InGroup)); first = false; list.Add(last); length -= 30; }
                while (length > 20) { last = new Note(NoteLength.nl2, notetype, (first ? NoteGroup.BeginGroup : NoteGroup.InGroup)); first = false; list.Add(last); length -= 20; }
                while (length > 15) { last = new Note(NoteLength.nl1_5, notetype, (first ? NoteGroup.BeginGroup : NoteGroup.InGroup)); first = false; list.Add(last); length -= 15; }
                while (length > 10) { last = new Note(NoteLength.nl1, notetype, (first ? NoteGroup.BeginGroup : NoteGroup.InGroup)); first = false; list.Add(last); length -= 10; }
                while (length > 5) { last = new Note(NoteLength.nl0_5, notetype, (first ? NoteGroup.BeginGroup : NoteGroup.InGroup)); first = false; list.Add(last); length -= 5; }

                if (tmp > 0)
                {
                    if (tmp > takt)
                    {
                        length = takt;
                        tmp = tmp - takt;
                    }
                    else
                    {
                        length = tmp;
                        left = takt - tmp;
                        tmp = 0;
                    }
                } else
                    process = false;
            }
            if (last.Group != NoteGroup.BeginGroup)
                last.Group = NoteGroup.EndGroup;
            else
                last.Group = NoteGroup.Nothing;

            return list;
        }

        NoteLength length;
        public NoteLength Length { get { return length; } }

        NoteType type;
        public NoteType Type { get { return type; } }

        NoteGroup grp;
        public NoteGroup Group { get { return grp; } set { grp = value; } }

        public Note(NoteLength length, NoteType type, NoteGroup grp)
        {
            this.length = length;
            this.type = type;
            this.grp = grp;
        }
    }
}
