﻿using System;

using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Xml;
using System.Drawing;
using System.Windows.Forms;
using System.ComponentModel;

namespace NotovyEditor
{
    class Notes
    {
        Image imgKlic;
        Image[] imgTakt;
        //Image nota4, nota2, nota1, nota05, nota4is, nota2is, nota1is, 
        //    nota05is, nota2_d, nota1_d, nota05_d, nota4is_d, nota2is_d, 
        //    nota1is_d, nota05is_d, pomlka4, pomlka2, pomlka1, pomlka0;

        Image[] noty_nahoru, noty_dolu, pomlky;
        public Notes()
        {
            imgKlic = global::NotovyEditor.Properties.Resources.klic;
            imgTakt = new Image[]{
                global::NotovyEditor.Properties.Resources.takt_3,
                global::NotovyEditor.Properties.Resources.takt_4,
                global::NotovyEditor.Properties.Resources.takt_5};


            noty_nahoru = new Image[] {
                global::NotovyEditor.Properties.Resources.nota_nahoru_0,
                global::NotovyEditor.Properties.Resources.nota_nahoru_1,
                global::NotovyEditor.Properties.Resources.nota_nahoru_2,
                global::NotovyEditor.Properties.Resources.nota_4,
                global::NotovyEditor.Properties.Resources.nota_krizek_nahoru_0,
                global::NotovyEditor.Properties.Resources.nota_krizek_nahoru_1,
                global::NotovyEditor.Properties.Resources.nota_krizek_nahoru_2,
                global::NotovyEditor.Properties.Resources.nota_krizek_4 };

            noty_dolu = new Image[] {
                global::NotovyEditor.Properties.Resources.nota_dolu_0,
                global::NotovyEditor.Properties.Resources.nota_dolu_1,
                global::NotovyEditor.Properties.Resources.nota_dolu_2,
                global::NotovyEditor.Properties.Resources.nota_4,
                global::NotovyEditor.Properties.Resources.nota_krizek_dolu_0,
                global::NotovyEditor.Properties.Resources.nota_krizek_dolu_1,
                global::NotovyEditor.Properties.Resources.nota_krizek_dolu_2,
                global::NotovyEditor.Properties.Resources.nota_krizek_4 };

            pomlky = new Image[] {
                global::NotovyEditor.Properties.Resources.pomlka_0,
                global::NotovyEditor.Properties.Resources.pomlka_1,
                global::NotovyEditor.Properties.Resources.pomlka_2,
                global::NotovyEditor.Properties.Resources.pomlka_4
            };

            //nota4 = global::NotovyEditor.Properties.Resources.nota_4;
            //nota4is = global::NotovyEditor.Properties.Resources.nota_krizek_4;

            //nota2 = global::NotovyEditor.Properties.Resources.nota_nahoru_2;
            //nota1 = global::NotovyEditor.Properties.Resources.nota_nahoru_1;
            //nota05 = global::NotovyEditor.Properties.Resources.nota_nahoru_0;

            //nota2is = global::NotovyEditor.Properties.Resources.nota_krizek_nahoru_2;
            //nota1is = global::NotovyEditor.Properties.Resources.nota_krizek_nahoru_1;
            //nota05is = global::NotovyEditor.Properties.Resources.nota_krizek_nahoru_0;

            //nota2_d = global::NotovyEditor.Properties.Resources.nota_dolu_2;
            //nota1_d = global::NotovyEditor.Properties.Resources.nota_dolu_1;
            //nota05_d = global::NotovyEditor.Properties.Resources.nota_dolu_0;

            //nota2is_d = global::NotovyEditor.Properties.Resources.nota_krizek_dolu_2;
            //nota1is_d = global::NotovyEditor.Properties.Resources.nota_krizek_dolu_1;
            //nota05is_d = global::NotovyEditor.Properties.Resources.nota_krizek_dolu_0;

            //pomlka4 = global::NotovyEditor.Properties.Resources.pomlka_4;
            //pomlka2 = global::NotovyEditor.Properties.Resources.pomlka_2;
            //pomlka1 = global::NotovyEditor.Properties.Resources.pomlka_1;
            //pomlka0 = global::NotovyEditor.Properties.Resources.pomlka_0;
        }

        Image GetImage(Note note)
        {
            int l = 0;
            switch (note.Length)
            {
                case NoteLength.nl4:
                    l = 3; break;
                case NoteLength.nl3:
                case NoteLength.nl2:
                    l = 2; break;
                case NoteLength.nl1_5:
                case NoteLength.nl1:
                    l = 1; break;
            }

            Image[] img = noty_nahoru;
            switch (note.Type)
            {
                case NoteType.Pause:
                    img = pomlky;
                    break;
                case NoteType.c:
                case NoteType.cis:
                case NoteType.d:
                case NoteType.dis:
                case NoteType.e:
                case NoteType.f:
                case NoteType.fis:
                case NoteType.g:
                case NoteType.gis:
                case NoteType.a:
                case NoteType.ais:
                case NoteType.h:
                    img = noty_dolu;
                    break;
            }

            switch (note.Type)
            {
                case NoteType.Cis:
                case NoteType.cis:
                case NoteType.Dis:
                case NoteType.dis:
                case NoteType.fis:
                case NoteType.Fis:
                case NoteType.Gis:
                case NoteType.gis:
                case NoteType.Ais:
                case NoteType.ais:
                    l += 4;
                    break;
            }

            return img[l];
        }

        int GetY(Note note)
        {
            int y = 0;
            int p = 35;
            switch (note.Type)
            {
                case NoteType.Pause:
                    y = 18 + 2 * 9;
                    break;
                case NoteType.C: y = 18 + 6 * 9 - p + 6; break;
                case NoteType.Cis: y = 18 + 6 * 9 - p + 6; break;
                case NoteType.D: y = 18 + 6 * 9 - p; break;
                case NoteType.Dis: y = 18 + 6 * 9 - p; break;
                case NoteType.E: y = 18 + 5 * 9 - p + 6; break;
                case NoteType.F: y = 18 + 5 * 9 - p + 6; break;
                case NoteType.Fis: y = 18 + 5 * 9 - p; break;
                case NoteType.G: y = 18 + 5 * 9 - p; break;
                case NoteType.Gis: y = 18 + 4 * 9 - p + 6; break;
                case NoteType.A: y = 18 + 4 * 9 - p + 6; break;
                case NoteType.Ais: y = 18 + 4 * 9 - p; break;
                case NoteType.H: y = 18 + 4 * 9 - p; break;
                case NoteType.c: y = 27; break;
                case NoteType.cis: y = 22; break;
                case NoteType.d: y = 22; break;
                case NoteType.dis: y = 18; break;
                case NoteType.e: y = 18; break;
                case NoteType.f: y = 13; break;
                case NoteType.fis: y = 9; break;
                case NoteType.g: y = 9; break;
                case NoteType.gis: y = 4; break;
                case NoteType.a: y = 4; break;
                case NoteType.ais: y = 0; break;
                case NoteType.h: y = 0; break;
            }
            return y;
        }

        int count;
        public int Count
        {
            get { return count; }
        }

        bool loaded = false;

        int takt = 0;

        //XmlDocument doc;
        //XmlNode root;

        List<Note> notes;

        public void LoadFromFile(string path)
        {
            if (File.Exists(path))
            {
                XmlDocument doc = new XmlDocument(); // kaslu na omezeni pameti ... minule taky nebyl problem si naalokovat 1GB :)

                try
                {
                    doc.Load(path);

                    XmlNode root = doc.SelectSingleNode("//skladba");
                    //count = root.ChildNodes.Count + 2;

                    if (root.Attributes["takt"] != null)
                    {
                        string t = root.Attributes["takt"].Value.Trim();
                        if (!int.TryParse(t.Split('/')[0], out takt))
                        {
                            takt = 0;
                        }
                        else takt -= 3;
                    }
                    else takt = 0;

                    notes = new List<Note>();

                    int left = (takt + 3) * 10;
                    float delka;

                    foreach (XmlNode node in root.ChildNodes)
                    {
                        if (node.Name.ToLower() == "pomlka")
                        {
                            if (node.Attributes["delka"] != null)
                            {

                                if (float.TryParse(node.Attributes["delka"].Value, out delka))
                                {
                                    notes.AddRange(Note.CreateNote((int)(delka*10), NoteType.Pause, (takt + 3) * 10, ref left));
                                }
                            }
                        }
                        else if (node.Name.ToLower() == "nota")
                        {
                            if (node.Attributes["delka"] != null && node.Attributes["vyska"] != null)
                            {
                                if (float.TryParse(node.Attributes["delka"].Value, out delka))
                                    notes.AddRange(Note.CreateNote((int)(delka * 10), Note.GetNoteType(node.Attributes["vyska"].Value), (takt + 3) * 10, ref left));
                            }
                        }
                    }

                    loaded = true;
                    count = notes.Count + 2;
                }
                catch
                {
                    // kde se stala chyba?
                }

            }
            else
            {
                // Soubor neexistuje!
            }
        }

        const int space = 5;
        const int yOffset = 18;
        const int linesOffset = 9;

        public void Draw(int position, Graphics g, Rectangle clipRect)
        {
            if (loaded)
            {

                g.Clear(Color.White);
                // vykreslíme notové čáry (nebo notovou osnovu nebo jak se tomu rika :))
                for (int i = 0; i < 5; i++)
                    g.DrawLine(Pens.Black, new Point(0, yOffset + i * linesOffset), new Point(clipRect.Width, yOffset + i * linesOffset));

                int xOffset = 0;
                int index = 0;

                if (position < 1)
                {
                    g.DrawImage(imgKlic, xOffset, yOffset);
                    xOffset += imgKlic.Size.Width + space;
                }

                if (position < 2)
                {
                    if (index >= 0)
                    {
                        g.DrawImage(imgTakt[takt], xOffset, yOffset);
                        xOffset += imgTakt[takt].Size.Width + space;
                    }
                }

                int pos = Math.Max(0,position - 2);
                
                //XmlNode node = root.FirstChild;
                //while (pos < position)
                //    node = node.NextSibling;

                while (xOffset < clipRect.Width && pos < notes.Count)
                {
                    Note n = notes[pos];
                    Image img = GetImage(n);

                    g.DrawImage(img, xOffset, GetY(n));
                    xOffset += imgTakt[takt].Size.Width + space;

                    pos++;
                }
            }
        }

    }
}
